#line 1 "C:/Users/Graham/Desktop/Projects/Infinity Mirror Clock/Code3/MirrorClock.c"
#line 51 "C:/Users/Graham/Desktop/Projects/Infinity Mirror Clock/Code3/MirrorClock.c"
sbit Melody_Out at RB3_bit;
sbit Melody_Out_Direction at TRISB3_bit;


sbit LEDOut at RC7_bit;
sbit LEDOut_Direction at TRISC7_bit;

sbit SET_Switch at RA0_bit;
sbit NEXT_Switch at RA1_bit;
sbit INC_Switch at RA2_bit;
sbit SET_Switch_Direction at TRISA0_bit;
sbit NEXT_Switch_Direction at TRISA1_bit;
sbit INC_Switch_Direction at TRISA2_bit;

sbit Clock_Switch at RA3_bit;
sbit Clock_Switch_Direction at TRISA3_bit;
sbit Sleep_Switch at RB2_bit;
sbit Sleep_Switch_Direction at TRISB2_bit;


sbit CS at RC0_bit;
sbit SoftSpi_SDO at RC1_bit;
sbit SoftSpi_CLK at RC2_bit;
sbit SoftSpi_SDI at RC6_bit;
sbit CS_direction at TRISC0_bit;
sbit SoftSpi_SDO_Direction at TRISC1_bit;
sbit SoftSpi_CLK_Direction at TRISC2_bit;
sbit SoftSpi_SDI_Direction at TRISC6_bit;
#line 102 "C:/Users/Graham/Desktop/Projects/Infinity Mirror Clock/Code3/MirrorClock.c"
unsigned char sleep_mode = 0;
const unsigned char NumberOfLeds = 60;
unsigned long led_strip[NumberOfLeds];
unsigned char Strip[NumberOfLeds * 24];
unsigned char second, minute, hour, day, day_number, date, month, year, r_data, Prev_hour, Prev_minute, Prev_second, Analog_hour, temp;


unsigned short Button(unsigned short *port, unsigned short pin, unsigned short debounce_time, unsigned short active_state);

void Beep()
{
 Sound_Play(300, 100);
}



void interrupt()
{
 if(INT2IF_bit == 1)
 {
 INT2IF_bit = 0;
 while(Sleep_Switch = 0);
 delay_ms(600);
 sleep_mode = ~sleep_mode;
 if(!sleep_mode)
 {
 asm reset;
 asm nop;
 }
 }
}


void Output_Strip()
{
 unsigned int y;

 for (y = 0; y < 1440; y++)
 {
 if (Strip[y] == 1)
 {
 LEDOut = 1;
 asm{
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 }
 }
 else
 {
 LEDOut = 1;
 asm{
 nop
 nop
 nop
 nop
 }
 }
 LEDOut = 0;
 }
 delay_us(75);
}


void CompileLEDDataStream()
{
 unsigned long this_led;
 unsigned char j, z;
 unsigned int s = 0;

 for (j = 0; j < NumberOfLeds; j++)
 {
 this_led = led_strip[j];
 for (z = 0; z < 24; z++)
 {
 if ( ((this_led) & (1 <<(23))) ) {Strip[s] = 1;} else {Strip[s] = 0;}
 s++;
 this_led *= 2;
 }
 }
 Output_Strip();
}



void Set_Color(unsigned long g, unsigned int r, char b, char position)
{
 led_strip[position] = (g << 16) | (r << 8) | b;
}



unsigned char BCD2UpperCh(unsigned char bcd)
{
 return ((bcd >> 4)+ '0');
}



unsigned char BCD2LowerCh(unsigned char bcd)
{
 return ((bcd & 0x0f) + '0');
}



unsigned short read_ds1307(unsigned short address)
{
 I2C1_Start();
 I2C1_Wr(0xD0);
 I2C1_Wr(address);
 I2C1_Repeated_Start();
 I2C1_Wr(0xD1);
 r_data = I2C1_Rd(0);
 I2C1_Stop();
 return r_data;
}



void write_ds1307(unsigned short address,unsigned short w_data)
{
 I2C1_Start();
 I2C1_Wr(0xD0);
 I2C1_Wr(address);
 I2C1_Wr(w_data);
 I2C1_Stop();
}



void Get_Time()
{
 second = read_ds1307(0);
 minute = read_ds1307(1);
 hour = read_ds1307(2);
 day = read_ds1307(3);
 date = read_ds1307(4);
 month = read_ds1307(5);
 year = read_ds1307(6);
}



void Set_Initial_Time()
{
 write_ds1307(0,0x80);
 write_ds1307(1,(Dec2Bcd(59)));
 write_ds1307(2,(Dec2Bcd(8)));
 write_ds1307(3,(Dec2Bcd(4)));
 write_ds1307(4,(Dec2Bcd(21)));
 write_ds1307(5,(Dec2Bcd(5)));
 write_ds1307(6,(Dec2Bcd(15)));
 write_ds1307(7,0x00);
 write_ds1307(0,0x00);
}



void send_to_max7219(char address, char dat)
{
 CS = 0;
 Soft_SPI_Write(address);
 Soft_SPI_Write(dat);
 CS = 1;
}



void init_MAX7219() {
 send_to_max7219(0x09,0xFF);
 send_to_max7219(0x0A,0x09);
 send_to_max7219(0x0B,0x07);
 send_to_max7219(0x0C,0x01);
 send_to_max7219(0x00,0x0F);
}



void Adjust_Time_Date()
{
 unsigned char set_count;
 if (Button(&PORTA, 0, 20, 0))
 {
 Beep();
 delay_ms(100);
 set_count = 1;
 send_to_max7219(0x01, BCD2UpperCh(hour));
 send_to_max7219(0x02, BCD2LowerCh(hour)+128);
 send_to_max7219(0x03, BCD2UpperCh(minute));
 send_to_max7219(0x04, BCD2LowerCh(minute));
 send_to_max7219(0x05, 0);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, 15);
 send_to_max7219(0x08, 15);

 while (Button(&PORTA, 0, 20, 0))
 {
 while (Button(&PORTA, 1, 20, 0))
 {
 delay_ms(425);
 set_count++;
 Beep();
 if(set_count > 5) set_count = 1;

 switch (set_count)
 {
 case 1:
 send_to_max7219(0x01, BCD2UpperCh(hour));
 send_to_max7219(0x02, BCD2LowerCh(hour)+128);
 send_to_max7219(0x03, BCD2UpperCh(minute));
 send_to_max7219(0x04, BCD2LowerCh(minute));
 send_to_max7219(0x05, 0);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, 15);
 send_to_max7219(0x08, 15);
 break;
 case 2:
 send_to_max7219(0x01, BCD2UpperCh(hour));
 send_to_max7219(0x02, BCD2LowerCh(hour));
 send_to_max7219(0x03, BCD2UpperCh(minute));
 send_to_max7219(0x04, BCD2LowerCh(minute)+128);
 send_to_max7219(0x05, 0);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, 15);
 send_to_max7219(0x08, 15);
 break;
 case 3:
 send_to_max7219(0x01, BCD2UpperCh(date));
 send_to_max7219(0x02, BCD2LowerCh(date));
 send_to_max7219(0x03, BCD2UpperCh(month));
 send_to_max7219(0x04, BCD2LowerCh(month)+128);
 send_to_max7219(0x05, 2);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, BCD2UpperCh(year));
 send_to_max7219(0x08, BCD2LowerCh(year));
 break;
 case 4:
 send_to_max7219(0x01, BCD2UpperCh(date));
 send_to_max7219(0x02, BCD2LowerCh(date)+128);
 send_to_max7219(0x03, BCD2UpperCh(month));
 send_to_max7219(0x04, BCD2LowerCh(month));
 send_to_max7219(0x05, 2);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, BCD2UpperCh(year));
 send_to_max7219(0x08, BCD2LowerCh(year));
 break;
 case 5:
 send_to_max7219(0x01, BCD2UpperCh(date));
 send_to_max7219(0x02, BCD2LowerCh(date));
 send_to_max7219(0x03, BCD2UpperCh(month));
 send_to_max7219(0x04, BCD2LowerCh(month));
 send_to_max7219(0x05, 2);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, BCD2UpperCh(year));
 send_to_max7219(0x08, BCD2LowerCh(year)+128);
 break;
 }
 }

 while (Button(&PORTA, 2, 20, 0))
 {
 delay_ms(425);
 Beep();
 switch (set_count)
 {
 case 1:
 hour++;
 write_ds1307(0,0x80);
 hour = BCD2dec(hour);
 if(hour > 23) hour = 0;
 write_ds1307(2,(dec2Bcd(hour)));
 write_ds1307(0,0x00);
 hour = read_ds1307(2);
 send_to_max7219(0x01, BCD2UpperCh(hour));
 send_to_max7219(0x02, BCD2LowerCh(hour)+128);
 break;
 case 2:
 minute++;
 write_ds1307(0,0x80);
 minute = BCD2dec(minute);
 if(minute > 59) minute = 0;
 write_ds1307(1, (Dec2Bcd(minute)));
 write_ds1307(0,0x00);
 minute = read_ds1307(1);
 send_to_max7219(0x03, BCD2UpperCh(minute));
 send_to_max7219(0x04, BCD2LowerCh(minute)+128);
 break;
 case 3:
 month++;
 write_ds1307(0,0x80);
 month = BCD2dec(month);
 if(month > 12) month = 1;
 write_ds1307(5,(Dec2Bcd(month)));
 write_ds1307(0,0x00);
 month = read_ds1307(5);
 send_to_max7219(0x03, BCD2UpperCh(month));
 send_to_max7219(0x04, BCD2LowerCh(month)+128);
 break;
 case 4:
 date++;
 write_ds1307(0,0x80);
 date = BCD2dec(date);

 switch(month)
 {
 case 1: if(date > 31) date = 1; break;
 case 2:
 if((date > 28) && (year % 4 != 0)) date = 1;
 if(date > 29 && year % 4 == 0) date = 1;
 break;
 case 3: if(date > 31) date = 1; break;
 case 4: if(date > 30) date = 1; break;
 case 5: if(date > 31) date = 1; break;
 case 6: if(date > 30) date = 1; break;
 case 7: if(date > 31) date = 1; break;
 case 9: if(date > 30) date = 1; break;
 case 10: if(date > 31) date = 1; break;
 case 11: if(date > 30) date = 1; break;
 case 12: if(date > 31) date = 1; break;
 }

 write_ds1307(4, (Dec2Bcd(date)));
 write_ds1307(0,0x00);
 date = read_ds1307(4);
 send_to_max7219(0x01, BCD2UpperCh(date));
 send_to_max7219(0x02, BCD2LowerCh(date)+128);
 break;
 case 5:
 year++;
 write_ds1307(0,0x80);
 year = BCD2dec(year);
 if(year >= 100) year = 0;
 write_ds1307(6, (Dec2Bcd(year)));
 write_ds1307(0,0x00);
 year = read_ds1307(6);
 send_to_max7219(0x07, BCD2UpperCh(year));
 send_to_max7219(0x08, BCD2LowerCh(year)+128);
 break;
 }
 }
 }
 }
}


void Clear_Strip()
{
 unsigned char pos;
 for(pos = 0; pos < NumberOfLeds; pos++)
 {
 led_strip[pos] = 0x000000;
 }
 CompileLEDDataStream();
}



unsigned long Strip_Color(char g, char r, char b)
{
 return ((unsigned long)g << 16) | ((unsigned long)r << 8) | b;
}




unsigned long Wheel(unsigned char WheelPos)
{
 if(WheelPos < 85)
 {
 return Strip_Color(WheelPos * 3, 255 - WheelPos * 3, 0);
 }
 else if(WheelPos < 170)
 {
 WheelPos -= 85;
 return Strip_Color(255 - WheelPos * 3, 0, WheelPos * 3);
 }
 else
 {
 WheelPos -= 170;
 return Strip_Color(0, WheelPos * 3, 255 - WheelPos * 3);
 }
}


void RandomColor(unsigned int loops)
{
 unsigned int a, b, c, d, j;
 for (j = 0; j < loops; j++)
 {
 srand(j);
 a = rand() % 255;
 b = rand() % 255;
 c = rand() % 255;
 d = rand() % NumberOfLeds;
 Set_Color(a, b, c, d);
 CompileLEDDataStream();
 }
}


void ChaseRandom(unsigned int loops)
{
 unsigned int x, j;
 unsigned long new_color = 0;
 for (j = 0; j < loops; j++)
 {
 for(x = (NumberOfLeds - 1); x > 0; x--)
 {
 led_strip[x] = led_strip[x - 1];
 }
 for(x = 0; x < 3; x++)
 {
 new_color <<= 8;
 new_color |= rand();
 }
 led_strip[0] = new_color;
 CompileLEDDataStream();
 }
}


void Fade_Strip(unsigned char greennext, unsigned char rednext, unsigned char bluenext, unsigned char greenlast, unsigned char redlast, unsigned char bluelast, unsigned char pos)
{
 float rlast, glast, blast, rcurr, gcurr, bcurr, rcalc, gcalc, bcalc;
 float MaxTemp, MaxStep, rtemp, gtemp, btemp;
 unsigned char b, nnn, count;
 unsigned long g, temp, temp1;
 unsigned int r;

 count = 0;
 gcurr = greenlast;
 rcurr = redlast;
 bcurr = bluelast;
 glast = greennext;
 rlast = rednext;
 blast = bluenext;
 MaxTemp = max((abs(gcurr - glast)), (abs(rcurr - rlast)));
 MaxStep = max((abs(bcurr - blast)), MaxTemp);
 gcalc = glast;
 rcalc = rlast;
 bcalc = blast;

 for (nnn = 0; nnn < MaxStep; nnn++)
 {
 gtemp = (gcurr - glast) / MaxStep;
 rtemp = (rcurr - rlast) / MaxStep;
 btemp = (bcurr - blast) / MaxStep;
 gcalc = gcalc + gtemp;
 rcalc = rcalc + rtemp;
 bcalc = bcalc + btemp;
 g = gcalc;
 r = rcalc;
 b = bcalc;

 temp = 0;
 temp1 = 0;
 temp1 = g << 16;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = r << 8;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = b;
 temp = temp + temp1;

 if(pos == 0)
 {
 for (count = 0; count <= NumberOfLeds; ++count)
 {
 led_strip[count] = temp;
 }
 }
 else
 {
 led_strip[pos] = temp;
 }
 Set_Color(g, r, b, pos);
 delay_ms(50);
 CompileLEDDataStream();
 }
}


void Solid_Strip(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned char x;
 for(x = 0; x < NumberOfLeds; x ++)
 {
 Set_Color(g, r, b, x);
 }
 CompileLEDDataStream();
}


void InsertColor(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned int x;
 for(x = (NumberOfLeds - 1); x > 0; x--)
 {
 led_strip[x] = led_strip[x - 1];
 }
 Set_Color(g, r, b, 0);
 CompileLEDDataStream();
}


void FillLeft(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned char count;
 for(count = NumberOfLeds; count > 0; count--)
 {
 Set_Color(g, r, b, count - 1);
 CompileLEDDataStream();
 }
}


void FillRight(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned char count;
 for(count = 0; count < NumberOfLeds; count++)
 {
 Set_Color(g, r, b, count);
 CompileLEDDataStream();
 }
}



void Fill_Any_PosR(unsigned char g1, unsigned char r1, unsigned char b1, unsigned char g2, unsigned char r2, unsigned char b2, unsigned char g3, unsigned char r3, unsigned char b3, unsigned char start, unsigned char end)
{
 unsigned char pos;
 for(pos = start; pos < end; pos++)
 {
 if((pos%3) == 0) {Set_Color(g3, r3, b3, pos);}
 if((pos%3) == 1) {Set_Color(g2, r2, b2, pos);}
 if((pos%3) == 2) {Set_Color(g1, r1, b1, pos);}

 CompileLEDDataStream();
 }
}



void Fill_Any_PosL(unsigned char g1, unsigned char r1, unsigned char b1, unsigned char g2, unsigned char r2, unsigned char b2, unsigned char g3, unsigned char r3, unsigned char b3, unsigned char start, unsigned char end)
{
 unsigned char pos;
 for(pos = start; pos > end; pos--)
 {
 if((pos%3) == 0) {Set_Color(g1, r1, b1, pos - 1);}
 if((pos%3) == 1) {Set_Color(g2, r2, b2, pos - 1);}
 if((pos%3) == 2) {Set_Color(g3, r3, b3, pos - 1);}

 CompileLEDDataStream();
 }
}


void Chase_3Color_Left(unsigned char g1, unsigned char r1, unsigned char b1, unsigned char g2, unsigned char r2, unsigned char b2, unsigned char g3, unsigned char r3, unsigned char b3, unsigned char repeat)
{
 unsigned char pos, loopframe;
 int strt;
 pos = NumberOfLeds;
 for(loopframe = 0; loopframe < repeat; loopframe++)
 {
 delay_ms(250);
 Set_Color(g3, r3, b3, pos + 2);
 Set_Color(g2, r2, b2, pos + 1);
 Set_Color(g1, r1, b1, pos);
 pos--;
 if (pos == NumberOfLeds - 3)
 {
 pos = NumberOfLeds;
 }
 for(strt = 0; strt < NumberOfLeds; strt++)
 {
 led_strip[strt] = led_strip[strt + 1];
 }
 CompileLEDDataStream();
 }
}


void Chase_3Color_Right(unsigned char g1, unsigned char r1, unsigned char b1, unsigned char g2, unsigned char r2, unsigned char b2, unsigned char g3, unsigned char r3, unsigned char b3, unsigned char repeat)
{
 unsigned char loopframe, pos;
 int strt;
 pos = 0;
 for(loopframe = 0; loopframe < repeat; loopframe++)
 {
 delay_ms(250);
 Set_Color(g1, r1, b1, pos - 0);
 Set_Color(g2, r2, b2, pos - 1);
 Set_Color(g3, r3, b3, pos - 2);
 pos++;
 if(pos == 3) pos = 0;

 for(strt = NumberOfLeds; strt >= 0; strt--)
 {
 led_strip[strt + 1] = led_strip[strt];
 }
 CompileLEDDataStream();
 }
}


void MovLeft_Chase_and_Clear(unsigned char position)
{
 unsigned char pos, loopframe;
 for(loopframe = 0; loopframe < position; loopframe++)
 {
 for(pos = 0; pos < NumberOfLeds; pos++)
 {
 led_strip[pos] = led_strip[pos + 1];
 }
 CompileLEDDataStream();
 delay_ms(100);
 led_strip[NumberOfLeds] = 0x000000;
 }
}


void MovRight_Chase_and_Clear(unsigned char position)
{
 unsigned char pos, loopframe;
 for(loopframe = 0; loopframe < position; loopframe++)
 {
 for(pos = (NumberOfLeds - 1); pos > 0; pos--)
 {
 led_strip[pos] = led_strip[pos - 1];
 }
 CompileLEDDataStream();
 delay_ms(100);
 led_strip[0] = 0x000000;
 }
}



void Fill_Dot (unsigned char g, unsigned char r, unsigned char b, unsigned char pos)
{
 Set_Color(g, r, b, pos);
 CompileLEDDataStream();
}


void Fill_Dot_PosR (unsigned char g, unsigned char r, unsigned char b, unsigned char start, unsigned char end)
{
 unsigned char pos;
 for(pos = start; pos <= end; pos++)
 {
 delay_ms(90);
 Set_Color(g, r, b, pos);
 CompileLEDDataStream();
 }
}


void Fill_Dot_PosL(unsigned char g, unsigned char r, unsigned char b, unsigned char start, unsigned char end)
{
 unsigned char pos;
 for(pos = start; pos >= end; pos--)
 {
 delay_ms(90);
 Set_Color(g, r, b, pos - 1);
 }
 CompileLEDDataStream();
}



void rainbowCycleLeft(unsigned char cycles)
{
 unsigned int j, i;
 for(j = 0; j < 256 * cycles; j++)
 {
 for(i = 0; i < NumberOfLeds; i++)
 {
 led_strip[i] = Wheel(((i * 256 / NumberOfLeds) + j) & 255);
 }
 CompileLEDDataStream();
 }
}



void rainbowCycleRight(unsigned char cycles)
{
 unsigned int j, i;
 for(j = 256 * cycles; j--;)
 {
 for(i = 0; i < NumberOfLeds; i++)
 {
 led_strip[i] = Wheel(((i * 256 / NumberOfLeds) + j) & 255);
 }
 CompileLEDDataStream();
 }
}


void CometLeft(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned char v;
 for(v = 0; v < NumberOfLeds; v++)
 {
 delay_ms(60);
 Set_Color(g, r, b, v);
 Set_Color(g / 2, r / 2, b / 2, v - 1);
 Set_Color(g / 4, r / 4, b / 4, v - 2);
 Set_Color(g / 8, r / 8, b / 8, v - 3);
 Set_Color(g / 16, r / 16, b / 16, v - 4);
 Set_Color(g / 32, r / 32, b / 32, v - 5);
 Set_Color(g / 64, r / 64, b / 64, v - 6);
 Set_Color(g / 128, r / 128, b / 128, v - 7);
 Set_Color(0, 0, 0, v - 8);
 CompileLEDDataStream();
 }
 Clear_Strip();
}


void CometRight(unsigned char g, unsigned char r, unsigned char b)
{
 unsigned char v;
 for(v = NumberOfLeds; v--;)
 {
 delay_ms(60);
 Set_Color(g, r, b, v - 9);
 Set_Color(g / 2, r / 2, b / 2, v - 8);
 Set_Color(g / 4, r / 4, b / 4, v - 7);
 Set_Color(g / 8, r / 8, b / 8, v - 6);
 Set_Color(g / 16, r / 16, b / 16, v - 5);
 Set_Color(g / 32, r / 32, b / 32, v - 4);
 Set_Color(g / 64, r / 64, b / 64, v - 3);
 Set_Color(g / 128, r / 128, b / 128, v - 2 );
 Set_Color(0, 0, 0, v - 1);
 CompileLEDDataStream();
 }
}



void Blank_MAX7219()
{
 send_to_max7219(0x01, 15);
 send_to_max7219(0x02, 15);
 send_to_max7219(0x03, 15);
 send_to_max7219(0x04, 15);
 send_to_max7219(0x05, 15);
 send_to_max7219(0x06, 15);
 send_to_max7219(0x07, 15);
 send_to_max7219(0x08, 15);
}



void Run_Patterns()
{
 unsigned char counter;
 Beep();
 if(Melody_Out == 1) {Melody_Out = 0;}
 Blank_MAX7219();
 Clear_Strip();


 RandomColor(100);

 CometRight( 0,255,0 );
 CometLeft( 255,0,0 );
 CometRight( 0,0,255 );
 CometLeft( 255,255,0 );

 rainbowCycleRight(2);
 rainbowCycleLeft(2);
 delay_ms(500);

 Clear_Strip();
 RandomColor(500);
 delay_ms(500);

 for(counter = 0; counter < 10; ++counter)
 {
 InsertColor( 0,0,0 );
 delay_ms(90);
 InsertColor( 245,40,100 );
 delay_ms(90);
 InsertColor( 0,255,255 );
 delay_ms(90);
 InsertColor( 255,255,0 );
 delay_ms(90);
 InsertColor( 30,255,12 );
 delay_ms(90);
 InsertColor( 0,255,0 );
 delay_ms(90);
 InsertColor( 255,255,255 );
 delay_ms(90);
 InsertColor( 3,220,3 );
 delay_ms(90);
 InsertColor( 255,0,0 );
 delay_ms(90);
 InsertColor( 20,255,0 );
 delay_ms(90);
 InsertColor( 0,0,255 );
 delay_ms(90);
 InsertColor( 220,100,47 );
 delay_ms(90);
 InsertColor( 0,75,130 );
 delay_ms(90);
 InsertColor( 254,64,20 );
 delay_ms(90);
 InsertColor( 206,135,255 );
 delay_ms(90);
 InsertColor( 160,255,0 );
 delay_ms(90);
 }
 Clear_Strip();

 Fill_Dot_PosR( 0,255,0 , 0, 59);
 delay_ms(100);
 Fill_Dot_PosR( 255,0,0 , 17, 45);
 delay_ms(100);
 Fill_Dot_PosR( 0,0,255 , 25, 35);

 delay_ms(500);
 Solid_Strip( 255,255,0 );
 delay_ms(500);
 Solid_Strip( 160,255,0 );
 delay_ms(500);
 Solid_Strip( 30,255,12 );
 delay_ms(500);
 Solid_Strip( 254,64,20 );
 delay_ms(500);
 Solid_Strip( 0,255,0 );
 delay_ms(500);

 MovLeft_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);
 MovRight_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);

 Solid_Strip( 245,40,100 );
 delay_ms(500);
 ChaseRandom(1000);
 RandomColor(1000);

 rainbowCycleRight(2);
 delay_ms(500);
 rainbowCycleLeft(2);
 delay_ms(500);

 FillLeft( 0,255,0 );
 delay_ms(200);
 FillRight( 0,0,0 );
 delay_ms(200);
 FillRight( 0,75,130 );
 delay_ms(200);
 FillRight( 0,0,0 );
 delay_ms(200);
 FillLeft( 3,220,3 );
 delay_ms(200);
 FillLeft( 0,0,0 );
 delay_ms(200);
 FillRight( 20,255,0 );
 delay_ms(200);
 FillRight( 0,0,0 );
 delay_ms(200);
 FillLeft( 254,64,20 );
 delay_ms(200);
 FillLeft( 0,0,0 );
 delay_ms(200);
 FillRight( 0,255,255 );
 delay_ms(200);
 FillLeft( 0,0,0 );
 delay_ms(200);
 FillLeft( 255,0,255 );
 delay_ms(200);
 FillRight( 0,0,0 );
 delay_ms(200);
 FillRight( 220,100,47 );
 FillRight( 0,0,0 );
 delay_ms(200);

 Chase_3Color_Right( 255,0,255 ,  20,255,0 ,  254,64,20 , 59);
 delay_ms(500);
 Fade_Strip( 0,0,0 ,  20,255,0 , 0);
 Fade_Strip( 20,255,0 ,  0,0,255 , 0);
 Fade_Strip( 0,0,255 ,  0,255,0 , 0);
 Fade_Strip( 0,255,0 ,  255,0,0 , 0);
 Fade_Strip( 255,0,0 ,  0,75,130 , 0);
 delay_ms(500);

 Chase_3Color_Right( 255,0,0 ,  0,255,0 ,  0,0,255 , 59);
 Chase_3Color_Left( 255,255,0 ,  255,0,255 ,  0,255,0 , 59);
 Chase_3Color_Right( 3,220,3 ,  206,135,255 ,  255,0,0 , 59);
 Chase_3Color_Left( 0,0,255 ,  0,75,130 ,  255,255,0 , 59);
 Chase_3Color_Right( 0,255,255 ,  220,100,47 ,  254,64,20 , 59);
 Chase_3Color_Left( 160,255,0 ,  30,255,12 ,  160,255,0 , 59);
 Chase_3Color_Right( 0,75,130 ,  245,40,100 ,  0,255,0 , 59);
 Chase_3Color_Left( 254,64,20 ,  0,0,255 ,  40,40,40 , 59);
 Chase_3Color_Right( 255,255,0 ,  255,255,255 ,  3,220,3 , 59);
 Chase_3Color_Left( 206,135,255 ,  30,255,12 ,  255,0,255 , 59);

 delay_ms(500);
 Fill_Any_PosR( 0,255,0 ,  0,0,255 ,  255,0,0 , 0, NumberOfLeds);
 delay_ms(500);
 MovLeft_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);
 Fill_Any_PosR( 0,255,0 ,  255,0,0 ,  255,255,0 , 0, NumberOfLeds);
 delay_ms(500);
 MovRight_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);
 FillLeft( 0,75,130 );
 delay_ms(500);
 Fill_Any_PosR( 0,255,255 ,  0,0,0 ,  0,0,0 , 0, NumberOfLeds);
 delay_ms(500);
 MovRight_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);
 Fill_Any_PosR( 160,255,0 ,  160,255,0 ,  160,255,0 , 0, NumberOfLeds);
 delay_ms(500);
 MovLeft_Chase_and_Clear(NumberOfLeds);
 delay_ms(500);
 FillRight( 206,135,255 );
 delay_ms(500);

 CometRight( 0,255,0 );
 CometLeft( 255,0,0 );
 CometRight( 0,0,255 );
 CometLeft( 255,255,0 );

 rainbowCycleRight(2);
 rainbowCycleLeft(2);

 RandomColor(1000);

 Fill_Any_PosL( 0,0,255 ,  255,255,0 ,  255,255,0 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 0,255,255 ,  0,0,0 ,  0,0,0 , 0, NumberOfLeds);
 delay_ms(500);

 Fill_Any_PosL( 254,64,20 ,  20,255,0 ,  30,255,12 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 0,255,255 ,  40,40,40 ,  0,75,130 , 0, NumberOfLeds);
 delay_ms(500);

 Fill_Any_PosL( 0,255,255 ,  0,0,255 ,  255,255,0 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 30,255,12 ,  220,100,47 ,  3,220,3 , 0, NumberOfLeds);
 delay_ms(500);

 Fill_Any_PosL( 40,40,40 ,  0,75,130 ,  40,40,40 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 0,0,255 ,  20,255,0 ,  254,64,20 , 0, NumberOfLeds);
 delay_ms(500);

 Fill_Any_PosL( 160,255,0 ,  255,0,255 ,  3,220,3 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 160,255,0 ,  245,40,100 ,  206,135,255 , 0, NumberOfLeds);
 delay_ms(500);

 Fill_Any_PosL( 0,255,0 ,  255,0,0 ,  0,255,0 , NumberOfLeds - 1, 0);
 delay_ms(500);

 Fill_Any_PosR( 0,255,0 ,  0,0,255 ,  0,0,0 , 0, NumberOfLeds);
 delay_ms(1000);

 Fill_Any_PosL( 0,255,0 ,  0,0,0 ,  0,0,0 , NumberOfLeds - 1, 0);
 delay_ms(1000);

 Clear_Strip();

 minute = BCD2dec(read_ds1307(1));
 delay_us(500);
 hour = BCD2dec(read_ds1307(2));
 delay_us(500);
 temp = read_ds1307(0);
 delay_us(500);
 temp &= 0x7F;

 write_ds1307(0,0x80);
 delay_us(500);
 write_ds1307(1,(Dec2Bcd(Minute)));
 delay_us(500);
 write_ds1307(2,(Dec2Bcd(Hour)));
 delay_us(500);
 write_ds1307(0, temp);
 delay_us(500);
}



void Run_Clock()
{
 unsigned char i, hour_pos;

 Get_Time();

 Adjust_Time_Date();

 send_to_max7219(0x01, BCD2UpperCh(date));
 send_to_max7219(0x02, BCD2LowerCh(date));
 send_to_max7219(0x03, BCD2UpperCh(month));
 send_to_max7219(0x04, BCD2LowerCh(month));
 send_to_max7219(0x05, 2);
 send_to_max7219(0x06, 0);
 send_to_max7219(0x07, BCD2UpperCh(year));
 send_to_max7219(0x08, BCD2LowerCh(year));

 led_strip[Prev_hour] = 0x000000;
 led_strip[Prev_minute] = 0x000000;
 led_strip[Prev_second] = 0x000000;

 Analog_hour = BCD2dec(hour);
 minute = BCD2dec(minute);
 second = BCD2dec(second);

 if(Analog_hour > 11){Analog_hour -= 12;}

 for(i = 0; i < NumberOfLeds; i ++)
 {
 if (i % 5 == 0){Set_Color( 20,50,0 , i);}
 }

 if(minute == 0 && second == 0){Melody_Out = 1;}
 if(minute == 0 && second == 26){delay_ms(500); Melody_Out = 0;}

 hour_pos = (Analog_hour * 5) + (minute / 12);

 Set_Color( 0,0,255 , hour_pos);
 Set_Color( 255,0,0 , minute);
 Set_Color( 0,255,0 , second);

 if (minute == hour_pos){Set_Color( 0,255,255 , hour_pos);}
 if (second == hour_pos){Set_Color( 0,0,255 , hour_pos);}
 if (second == minute){Set_Color( 255,0,0 , minute);}

 Prev_hour = hour_pos;
 Prev_minute = minute;
 Prev_second = second;

 CompileLEDDataStream();
}


void main() {

 CMCON = 7;
 ADCON0 = 0b00000000;
 ADCON1 = 0b00001111;

 PORTA = 0;
 PORTB = 0;
 PORTC = 0;
 TRISA = 0b00001111;
 TRISB = 0b00000101;
 TRISC = 0b00000000;
 I2C1_Init(100000);
 delay_ms(150);

 delay_ms(150);
 Soft_SPI_Init();
 delay_ms(100);
 init_MAX7219();
 delay_ms(100);

 Sound_Init(&PORTB, 4);

 GIE_bit = 1;
 INTEDG2_bit = 0;
 INT2IE_bit = 1;

 Clear_Strip();

 Get_Time();

 temp = read_ds1307(0);
 delay_us(500);
 temp &= 0x7F;
 write_ds1307(0, temp);
 delay_us(500);

 do
 {
 if(sleep_mode)
 {
 Blank_MAX7219();
 Clear_Strip();
 delay_ms(100);
 asm sleep;
 asm nop;
 }

 if(Button(&PORTA, 3, 50, 0)) Run_Patterns();

 Run_Clock();

 }while(1);
}
